# -*- coding: utf-8 -*-
# version 1.0

import os
import sys
import re
import binascii
import argparse
import string

parser = argparse.ArgumentParser()
parser.add_argument('inputfile', action='store', help='Input a CIA file, or a directory that will be recursively searched for CIA files with filenames ending in \'.cia\'')
arguments = parser.parse_args()

logfile = 'output_titleid.txt'

def writeInLog(msg):
    f = open(logfile, "a")
    f.write(msg+"\n")
    f.close()

print '*******\nExtractTitleIDCIA\n*******\n'

def tmdProcess(fpath):
    # print '**********'
    with open(fpath) as f:
        cia = f.read()
        print os.path.basename(fpath) + ' - ' + binascii.hexlify(cia[0x2C1C:0x2C24] + binascii.hexlify(cia[0x3A50:0x3A5F])
        writeInLog(os.path.basename(fpath) + ' - ' + binascii.hexlify(cia[0x2C1C:0x2C24]) + binascii.hexlify(cia[0x3A50:0x3A5F]))

    print ''

if os.path.exists(arguments.inputfile):
    if (os.path.isdir(arguments.inputfile)):
        for dname, dirs, files in os.walk(arguments.inputfile):
            for fname in files:
                if(fname.lower().endswith('cia')):  # if(fname.lower() == 'tmd'):
                    fpath = os.path.join(dname, fname)
                    if os.path.isfile(fpath):
                        tmdProcess(fpath)

    elif os.path.isfile(arguments.inputfile):
        tmdProcess(arguments.inputfile)

print 'Finished'
